using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace Miroslaw.APCF.Iface
{
    [AttributeUsage(AttributeTargets.Assembly, AllowMultiple = true)]
    public class DfltFactoryAttribute : FactoryAttribute
    {
        private ConstructorInfo _ci;

        public DfltFactoryAttribute(Type t)
            : base (t)
        {
            _ci = t.GetConstructor(new Type[] { });
            if (_ci == null)
                throw new ArgumentException("needs default ctor");
        }

        public override IProductEditor CreateFactory()
        {
            return (Iface.IProductEditor)_ci.Invoke(new object[] { });
        }
    }
}
