using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace Miroslaw.APCF.Iface
{
    public class Loader
    {
        Dictionary<Guid, IProductEditor> _factories = new Dictionary<Guid, IProductEditor>();

        public Loader()
        {
        }

        public void LoadFactories(Assembly a)
        {
            FactoryAttribute[] pfs = (FactoryAttribute[])a.GetCustomAttributes(typeof(FactoryAttribute), true);
            foreach (FactoryAttribute pf in pfs)
            {
                IProductEditor f = pf.CreateFactory();
                _factories.Add(f.Guid, f);
            }
        }

        public IProductEditor GetEditor(Guid guid)
        {
            return _factories[guid];
        }

        public IProductEditor[] GetEditors()
        {
            IProductEditor[] retval = new IProductEditor[_factories.Count];
            _factories.Values.CopyTo (retval, 0);
            return retval;
        }
    }
}
