using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace Miroslaw.APCF.PF
{
    [AttributeUsage (AttributeTargets.Assembly, AllowMultiple=true)]
    public class ParamFactoryAttribute : Iface.FactoryAttribute
    {
        private ConstructorInfo _ci;

        public ParamFactoryAttribute(Type t)
            : base (t)
        {
            _ci = t.GetConstructor(new Type[] { });
            if (_ci == null)
                throw new ArgumentException("needs default ctor");
        }

        public override Iface.IProductEditor CreateFactory()
        {
            return (Iface.IProductEditor)_ci.Invoke(new object[] { });
        }
    }
}
